'From VisualWorks® NonCommercial, Release 7 of June 14, 2002 on June 16, 2003 at 10:05:24 am'!


CormasNS.Models defineNameSpace: #Djemiong
	private: false
	imports: '
			private Smalltalk.*
			private CormasNS.Kernel.*
			'
	category: 'DjemiongCategory'!


CormasNS.Models.Djemiong defineClass: #Cell
	superclass: #{CormasNS.Kernel.SpatialEntityElement}
	indexedType: #none
	private: false
	instanceVariableNames: 'road river huntingLocality huntingPressure crop isHunted '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Djemiong'!

CormasNS.Models.Djemiong.Cell defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Djemiong.Cell class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Djemiong.Cell methodsFor: 'accessing'!

crop
	^crop!

crop: uneValeur 
	crop := uneValeur asNumber!

huntingLocality
	^huntingLocality!

huntingLocality: uneValeur 
	huntingLocality := uneValeur!

huntingPressure
	^huntingPressure!

huntingPressure: uneValeur 
	uneValeur isInteger
		ifFalse: [huntingPressure := uneValeur asNumber]
		ifTrue: [huntingPressure := uneValeur].
	self defineVisualState.
	self show!

isHunted
	^isHunted!

isHunted: uneValeur 
	isHunted := uneValeur!

river
	^river!

river: uneValeur 
	river := uneValeur!

road
	^road!

road: uneValeur 
	road := uneValeur! !

!CormasNS.Models.Djemiong.Cell methodsFor: 'procedures'!

isHabitat
	^self river = false and: [self road = false]! !

!CormasNS.Models.Djemiong.Cell methodsFor: 'pov'!

povAll
	self huntingLocality isNil ifTrue: [^#nothing].
	self road ifTrue: [^#road].
	self river ifTrue: [^#river]!

povHuntingPressure
	self huntingLocality isNil ifTrue: [^#nothing].
	self huntingPressure isNil | (self huntingPressure = 0)
		ifFalse: [^#chasse]
		ifTrue: [^#huntingLocality]!

povHuntingPressureRoadRiver
	self huntingLocality isNil ifTrue: [^#nothing].
	self huntingPressure isNil | (self huntingPressure = 0)
		ifFalse: [^#chasse]
		ifTrue: [^self povRoadRiver]!

povIsHunted
	self huntingLocality isNil ifTrue: [^#nothing].
	self isHunted isNil ifTrue: [^#huntingLocality].
	self isHunted ifTrue: [^#chasse] ifFalse: [^#huntingLocality]!

povIsHuntedRoadRiver
	self huntingLocality isNil ifTrue: [^#nothing].
	self isHunted isNil ifTrue: [^self povRoadRiver].
	self isHunted ifTrue: [^#chasse] ifFalse: [^self povRoadRiver]!

povRiver
	self huntingLocality isNil ifTrue: [^#nothing].
	self river ifTrue: [^#river] ifFalse: [^#huntingLocality]!

povRoad
	self huntingLocality isNil ifTrue: [^#nothing].
	self road ifTrue: [^#road] ifFalse: [^#huntingLocality]!

povRoadRiver
	self huntingLocality isNil ifTrue: [^#nothing].
	self road ifTrue: [^#road].
	self river ifTrue: [^#river].
	^#huntingLocality!

povTerritory
	^self huntingLocality isNil ifTrue: [#nothing] ifFalse: [#huntingLocality]! !

!CormasNS.Models.Djemiong.Cell methodsFor: 'init'!

init
	super init.
	self isHunted: false.
	self huntingPressure: 0!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !


CormasNS.Models.Djemiong defineClass: #Djemiong
	superclass: #{CormasNS.Kernel.CormasModel}
	indexedType: #none
	private: false
	instanceVariableNames: 'theCells theDuikers cephal theHunters theHuntingLocalitys theHuntingGroups catchesNumber '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Djemiong'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Djemiong.Djemiong class methodsFor: 'description'!

aboutIt
	| txt |
	txt := 'This model is based on a study of blue duiker hunting in Djemiong, 
a forest village in eastern Cameroon. The aim of the study is to understand 
how the organization of the hunting activity between villagers constitutes 
a management system. The main species hunted is a small antelope, the 
blue duiker (Cephalophus monticola, Thunberg). Surveys were conducted 
to understand the inhabitants'' hunting behaviour. Hunting takes place 
6 months/year and is subject to a spatial shifting rule. Every year, each 
hunter changes the location of his traps. This behaviour is presented 
as a management rule that is implemented by the hunters. 

The model is used to compare different rules for trap locations in spaceModel 
and time. It is based on the life history of the blue-duiker and on the 
inhabitants'' hunting behaviour. The model incorporates data from a 
geographical information system (GIS) to create an artificial landscape 
that resembles the village landscape. The results highlight the importance 
of coordination between hunters, particularly the fact that trap networks 
are appropriated by family groups. The spatial location of traps seems 
to have a much more crucial influence on the model than the global 
hunting pressure and the duration of the not hunted season.

For more information, look at the paper:
  Bousquet, F., Le Page, C., Bakam, I. and Takforyan, A., 2001. 
       A spatially explicit individual-based model of blue duikers population 
       dynamics: multi-agent simulation of bushmeat hunting in an eastern 
       cameroonian village. Ecological Modelling, 138(1-3): 331-346.'
				asText emphasizeAllWith: #(#bold).
	ComposedTextView open: txt asValue
		label: 'About ' , self name
		icon: (Icon constantNamed: #workspace)
		extent: 520 @ 540!

howToRunIt
| txt |
txt := '1. Prepare the visualisation of the spatial grid\' withCRs asText emphasizeAllWith: #(#bold #large).
txt := txt, '1.1 Click on the first icon of the ' asText, ('Visualisation ' asText emphasizeAllWith: #color -> ColorValue red), 'area to open the standard spatial grid.\' withCRs asText.
txt := txt, '1.2 From the spatial grid menu, use ' asText, ('Tools -> Load an environment' asText emphasizeAllWith: #italic), ', select ' asText, ('Dejmiong.env ' asText emphasizeAllWith: #italic), 'and validate. This will initialize the grid with the borders of the Djemiong village and assign values to the cell attributes ' asText, ('huntingLocality ' asText emphasizeAllWith: #italic), ',' asText, ('road ' asText emphasizeAllWith: #italic), 'and ' asText, ('river.\' withCRs asText emphasizeAllWith: #italic).
txt := txt, '1.3 Right-click within the spatial grid window to select the ' asText, ('povRoadRiver ' asText emphasizeAllWith: #italic), 'view for ' asText, ('Cell ' asText emphasizeAllWith: #italic), '.\' withCRs asText.
txt := txt, '1.4 Right-click within the spatial grid window to select the ' asText, ('povCouple ' asText emphasizeAllWith: #italic), 'view for ' asText, ('Duiker ' asText emphasizeAllWith: #italic), '.\' withCRs asText.
txt := txt, '1.5 To display the legend of these viewpoints, from the spatial grid menu, use ' asText, ('Tools -> Display legends.\' withCRs asText emphasizeAllWith: #italic).
txt := txt, '1.6 To hide the delimitation lines between cells, from the spatial grid menu, uncheck ' asText, ('Topology -> Graphic options -> Cell delimitation\\' withCRs asText emphasizeAllWith: #italic).

txt := txt, ('2. Run the version without hunting\' withCRs asText emphasizeAllWith: #(#bold #large)).
txt := txt, '2.1 Click on the ' asText, ('Initialize ' asText emphasizeAllWith: #italic), 'button of the ' asText, ('Simulation ' asText emphasizeAllWith: #color -> ColorValue red),  'area.\' withCRs asText.
txt := txt, '2.2 Select the ' asText, ('initPopulation ' asText emphasizeAllWith: #italic), 'and ' asText, ('stepPopulation: ' asText emphasizeAllWith: #italic), 'methods, then validate by clicking on ' asText, ('Apply and close.\' asText emphasizeAllWith: #italic) withCRs asText.
txt := txt, '2.3 Enter 104 (with a weekly time-step, this corresponds to 2 years) in the ' asText, ('Final time ' asText emphasizeAllWith: #italic), 'input field of the ' asText,  ('Simulation ' asText emphasizeAllWith: #color -> ColorValue red),  'area.\' withCRs asText.
txt := txt, '2.4 Click on the ' asText, ('Run ' asText emphasizeAllWith: #italic), 'button of the ' asText,  ('Simulation ' asText emphasizeAllWith: #color -> ColorValue red),  'area.\\' withCRs asText.

txt := txt, ('3. Have a look at the charts\' withCRs asText emphasizeAllWith: #(#bold #large)).
txt := txt, '3.1 Click on the third icon of the ' asText, ('Visualisation ' asText emphasizeAllWith: #color -> ColorValue red), 'area to open the charts window.\\' withCRs asText.

txt := txt, ('4. Run the basic version of the model with hunting\' withCRs asText emphasizeAllWith: #(#bold #large)).
txt := txt, '4.1 Click on the ' asText, ('Initialize ' asText emphasizeAllWith: #italic), 'button of the ' asText, ('Simulation ' asText emphasizeAllWith: #color -> ColorValue red),  'area.\' withCRs asText.
txt := txt, '4.2 Select the ' asText, ('initHunting ' asText emphasizeAllWith: #italic), 'and ' asText, ('stepHunting: ' asText emphasizeAllWith: #italic), 'methods, then validate by clicking on ' asText, ('Apply and close.\' asText emphasizeAllWith: #italic) withCRs asText.
txt := txt, '4.3 Right-click within the spatial grid window to select the ' asText, ('povHuntingPressureRoadRiver ' asText emphasizeAllWith: #italic), 'view for ' asText, ('Cell ' asText emphasizeAllWith: #italic), '. The red color corresponds to the presence of traps.\' withCRs asText.
txt := txt, '4.4 Run the model again.' withCRs asText.
ComposedTextView open: txt asValue label: ('How to run ', self name, '     step-by-step instructions') icon: (Icon constantNamed: #workspace) extent: 640@600! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Djemiong.Djemiong methodsFor: 'accessing'!

catchesNumber: aValue
	catchesNumber := aValue!

theCells
	^theCells!

theCells: x 
	theCells := x!

theDuikers
	^theDuikers!

theDuikers: x 
	theDuikers := x!

theHunters
	^theHunters!

theHunters: x 
	theHunters := x!

theHuntingGroups
	^theHuntingGroups!

theHuntingGroups: x 
	theHuntingGroups := x!

theHuntingLocalitys
	^theHuntingLocalitys!

theHuntingLocalitys: x 
	theHuntingLocalitys := x! !

!CormasNS.Models.Djemiong.Djemiong methodsFor: 'init'!

initHunting
	self initPopulation.
	self definirChasseAgri: (self lectureActesChasseFichier: 'Chass95a.img')
		surface: 8.
	self theCells do: [:a | a huntingPressure: 0].!

initPopulation
	self initSpace.
	self initAgregatsClp.
	self initAgents.
	self catchesNumber: 0.! !

!CormasNS.Models.Djemiong.Djemiong methodsFor: 'control'!

stepHunting: unTemps 
	| j nomFichier |
	j := 85.
	unTemps // 52 = (unTemps / 52) ifTrue: [self retirerChasse].
	unTemps + 26 // 52 = (unTemps + 26 / 52)
		ifTrue: 
			["[nomFichier := 'chass' , (j + (unTemps // 52)) printString , 
			'a.img'."
			"nomFichier := 'chass95a.img'.
			self
				repartirChasse: (self lectureActesChasseFichier: nomFichier)
				surface: 15
				pression: 25."
			self activerChasse: 150.
			j := j + 1].
	self stepPopulation: unTemps!

stepPopulation: unTemps 
	| tmp horloge theDeadDuikers |
	horloge := unTemps.
	tmp := OrderedCollection new.
	self catchesNumber: 0.
	self theDuikers do: 
			[:unCephaloph | 
			| nouveau |
			(nouveau := unCephaloph evoluer: horloge) class = Duiker
				ifTrue: 
					[tmp add: nouveau.
					unCephaloph ageMiseBas: unCephaloph age]
				ifFalse: 
					[self catchesNumber: self catchesNumber + nouveau.
					nouveau = 1 ifTrue: 
							["l := self theHuntingLocalitys
										detect: [:a | a components includes: unCephaloph patch].
							l resultats: l resultats + nouveau"]]].
	theDeadDuikers := self theDuikers select: [:c | c dead].
	theDeadDuikers do: [:dd | dd leave. self theDuikers remove: dd].
	self theDuikers addAll: tmp.
self updateData: unTemps! !

!CormasNS.Models.Djemiong.Djemiong methodsFor: 'procedures'!

activerChasse: p 
	self theCells do: 
			[:c | 
			c isHunted ifTrue: [c huntingPressure: p] ifFalse: [c huntingPressure: 0]]!

choixActesChasse
	| dicoActesChasse lieuDitChasse nbActes m texte |
	dicoActesChasse := Dictionary new.
	1 to: 30 do: [:i | dicoActesChasse at: i printString put: 0].
	m := 0.
	self theHunters do: 
			[:unChasseur | 
			m := m + 1.
			lieuDitChasse := unChasseur choixLieuDit printString.
			texte := 'chasseur' , m printString , ': ' , lieuDitChasse.
			texte printOn: Transcript.
			Transcript cr.
			nbActes := dicoActesChasse at: lieuDitChasse.
			dicoActesChasse at: lieuDitChasse put: nbActes + 1].
	Transcript cr.
	Transcript flush.
	^dicoActesChasse!

choixActesChasse: p 
	| lieuDitChasse m texte |
	m := 0.
	self theHunters do: 
			[:unChasseur | 
			m := m + 1.
			lieuDitChasse := unChasseur choixLieuDit.
			(unChasseur terrainsChasse at: lieuDitChasse) components
				do: [:aCell | aCell huntingPressure: p].
			texte := 'chasseur' , m printString , ': ' , lieuDitChasse printString.
			texte printOn: Transcript.
			Transcript cr].
	Transcript cr.
	Transcript flush!

choixGroupesChasse: p 
	| m |
	m := 0.
	self theHuntingGroups do: 
			[:unGroupe | 
			m := m + 1.
			unGroupe choixTerrains do: [:aCell | aCell huntingPressure: p]]!

definirChasse: lesActesDeChasse surface: s 
	| cellLieu cellLibres cellBase j attaquees precedent |
	lesActesDeChasse keysAndValuesDo: 
			[:leLieu :nbActes | 
			cellLieu := (self theCells select: [:aCell | aCell huntingLocality = leLieu])
						asOrderedCollection.
			nbActes * s >= cellLieu size
				ifTrue: [cellLieu do: [:aCell | aCell isHunted: true]]
				ifFalse: 
					[cellLieu do: [:aCell | aCell isHunted: false].
					cellLibres := cellLieu copy.
					nbActes timesRepeat: 
							[cellBase := Cormas selectRandomlyFrom: cellLibres.
							cellBase isHunted: true.
							cellLibres remove: cellBase.
							j := 1.
							attaquees := OrderedCollection new.
							precedent := -2.
							[attaquees size >= (s - 1) or: [precedent = (attaquees size - 1)]]
								whileFalse: 
									[precedent := attaquees size - 1.
									attaquees := (cellBase recursiveNeighbourhood: j) select: 
													[:aCell | 
													aCell huntingLocality = cellBase huntingLocality and: [aCell isHunted not]].
									j := j + 1].
							j := 1.
							attaquees do: 
									[:aCell | 
									j <= s ifTrue: 
											[aCell isHunted: true.
											cellLibres remove: aCell].
									j := j + 1]]]]!

definirChasseAgri: lesActesDeChasse surface: surf 
	| cellLieu cellLibres cellBase j attaquees precedent s |
	lesActesDeChasse keysAndValuesDo: 
			[:leLieu :nbActes | 
			leLieu = '28' | (leLieu = '5') | (leLieu = '11') | (leLieu = '14')
				| (leLieu = '12') | (leLieu = '2') | (leLieu = '1') | (leLieu = '10')
				| (leLieu = '26') | (leLieu = '3')
				ifTrue: [s := surf * 3 / 2]
				ifFalse: [s := surf / 2].
			cellLieu := (self theCells select: [:aCell | aCell huntingLocality = leLieu])
						asOrderedCollection.
			nbActes * s >= cellLieu size
				ifTrue: [cellLieu do: [:aCell | aCell isHunted: true]]
				ifFalse: 
					[cellLieu do: [:aCell | aCell isHunted: false].
					cellLibres := cellLieu copy.
					nbActes timesRepeat: 
							[cellLibres size = 0
								ifTrue: [cellLieu do: [:aCell | aCell isHunted: false]]
								ifFalse: 
									[cellBase := Cormas selectRandomlyFrom: cellLibres.
									cellBase isHunted: true.
									cellLibres remove: cellBase.
									j := 1.
									attaquees := OrderedCollection new.
									precedent := -2.
									[attaquees size >= (s - 1) or: [precedent = (attaquees size - 1)]]
										whileFalse: 
											[precedent := attaquees size - 1.
											attaquees := (cellBase recursiveNeighbourhood: j) select: 
															[:aCell | 
															aCell huntingLocality = cellBase huntingLocality and: [aCell isHunted not]].
											j := j + 1].
									j := 1.
									attaquees do: 
											[:aCell | 
											j <= s ifTrue: 
													[aCell isHunted: true.
													cellLibres remove: aCell ifAbsent:[nil]].
											j := j + 1]]]]]!

definirChasseAgriNoRR: lesActesDeChasse surface: surf 
	| cellLieu cellLibres cellBase j attaquees precedent s |
	lesActesDeChasse keysAndValuesDo: 
			[:leLieu :nbActes | 
			leLieu = '28' | (leLieu = '5') | (leLieu = '11') | (leLieu = '14')
				| (leLieu = '12') | (leLieu = '2') | (leLieu = '1') | (leLieu = '10')
				| (leLieu = '26') | (leLieu = '3')
				ifTrue: [s := surf * 2]
				ifFalse: [s := surf / 2].
			cellLieu := (self theCells
						select: [:aCell | aCell huntingLocality = leLieu and: [aCell isHabitat]])
							asOrderedCollection.
			nbActes * s >= cellLieu size
				ifTrue: [cellLieu do: [:aCell | aCell isHunted: true]]
				ifFalse: 
					[cellLieu do: [:aCell | aCell isHunted: false].
					cellLibres := cellLieu copy.
					nbActes timesRepeat: 
							[cellLibres size = 0
								ifTrue: [cellLieu do: [:aCell | aCell isHunted: false]]
								ifFalse: 
									[cellBase := Cormas selectRandomlyFrom: cellLibres.
									cellBase isHunted: true.
									cellLibres remove: cellBase.
									j := 1.
									attaquees := OrderedCollection new.
									precedent := -2.
									[attaquees size >= (s - 1) or: [precedent = (attaquees size - 1)]]
										whileFalse: 
											[precedent := attaquees size - 1.
											attaquees := (cellBase recursiveNeighbourhood: j) select: 
															[:aCell | 
															aCell huntingLocality = cellBase huntingLocality
																and: [aCell isHunted not and: [aCell isHabitat]]].
											j := j + 1].
									j := 1.
									attaquees do: 
											[:aCell | 
											j <= s ifTrue: 
													[aCell isHunted: true.
													cellLibres remove: aCell].
											j := j + 1]]]]]!

evoluer: unTemps nSimul: n

	self evoluer: unTemps.

	unTemps = 5000
		ifTrue: [self sauver: '0_pop' , (n) printString , '.txt'.
			    self sauverPopu: '0_popS', n printString, '.txt'].!

evoluer: unTemps saveCapt: file 
	| tmp ageClass compteurChasse cptEffTerritoire femellesEnCouple effTerritoire cptMB sumIAMB l horloge |
	horloge := unTemps.
	tmp := OrderedCollection new.
	compteurChasse := 0.
	cptMB := 0.
	sumIAMB := 0.	"cephal := OrderedCollection new.
	lesCephalophes do: [:a | cephal add: a copy]. self halt."
	self theDuikers do: 
			[:unCephaloph | 
			| nouveau |
			(nouveau := unCephaloph evoluer: horloge) class = Duiker
				ifTrue: 
					[unCephaloph ageMiseBas = 0 ifFalse: 
							[cptMB := cptMB + 1.
							sumIAMB := sumIAMB + unCephaloph age - unCephaloph ageMiseBas].
					unCephaloph ageMiseBas: unCephaloph age.
					tmp add: nouveau]
				ifFalse: 
					["compteurChasse := compteurChasse + nouveau."

					nouveau = 1 ifTrue: 
							[l := self theHuntingLocalitys
										detect: [:a | a components includes: unCephaloph patch].
							l resultats: l resultats + nouveau].
					self sauverCephal: unCephaloph inFile: file]].
	tmp do: 
			[:unPetit | 
			self theDuikers add: unPetit.
			unPetit moveTo: unPetit patch].
	(self theDuikers
		removeAllSuchThat: [:unCephaloph | unCephaloph dead])
			do: [:unCephaloph | unCephaloph leave].
	horloge := horloge + 1.
	bebes value add: (Array with: tmp size with: unTemps).
	captures value add: (Array with: compteurChasse with: unTemps).
	cptMB = 0
		ifTrue: 
			["Intervalle moyen entre 2 mises bas"

			i2ns value add: (Array with: 0 with: unTemps)]
		ifFalse: [i2ns value add: (Array with: sumIAMB / cptMB with: unTemps)].	"Territoire: couple installe + autres individus solitaires"
	cptEffTerritoire := 0.
	femellesEnCouple := self theDuikers
				select: [:a | a sexe = #femelle and: [a partner notNil]].
	femellesEnCouple do: 
			[:f | 
			effTerritoire := (f patch theOccupants at: #Duiker) size.
			cptEffTerritoire := cptEffTerritoire + effTerritoire].
	femellesEnCouple isEmpty
		ifTrue: [occupation value add: (Array with: 0 with: unTemps)]
		ifFalse: 
			[occupation value
				add: (Array with: cptEffTerritoire / femellesEnCouple size with: unTemps)].	"Densite de la population de cephalophes (la carte represente une aire de 1658 cellules x 3ha = 49.74 
	km2)"
	populationTotale value
		add: (Array with: self theDuikers size / 49.74 with: unTemps).	"un indice de pression de chasse"
	self espaceChasse value add: (Array
				with: (self theCells select: [:a | a huntingPressure > 0]) size
				with: unTemps).	"Structure en age de la population de cephalophes"
	ageClass := OrderedCollection new.
	ageClass
		add: (Array with: (self theDuikers select: [:a | a age < 53]) size
				with: '1').
	ageClass add: (Array
					with: (self theDuikers select: [:a | a age > 52 and: [a age < 105]])
							size
					with: '2');
		add: (Array
					with: (self theDuikers select: [:a | a age > 104 and: [a age < 157]])
							size
					with: '3');
		add: (Array
					with: (self theDuikers select: [:a | a age > 156 and: [a age < 209]])
							size
					with: '4');
		add: (Array
					with: (self theDuikers select: [:a | a age > 208 and: [a age < 261]])
							size
					with: '5');
		add: (Array
					with: (self theDuikers select: [:a | a age > 260 and: [a age < 313]])
							size
					with: '6');
		add: (Array
					with: (self theDuikers select: [:a | a age > 312 and: [a age < 365]])
							size
					with: '7');
		add: (Array
					with: (self theDuikers select: [:a | a age > 364 and: [a age < 417]])
							size
					with: '8').
	classeAge := ValueHolder with: ageClass.
	self theDuikers isEmpty ifTrue: [^nil]!

evoluerChasse: unTemps nSimul: n 
	| j nomFichier aSurface p |
	j := 85.
	"unTemps = 0 ifTrue: [self ouvrirFichier: 'captLieus' , n printString , '.txt']."
	unTemps // 52 = (unTemps / 52) ifTrue: [self retirerChasse].
	unTemps = 1300
		ifTrue: 
			[self sauver: '1_popdjemiong' , (n) printString , '.txt'.
			self sauverCaptures: '1_captdjemiong' , (n) printString , '.txt'.
			self sauverIndice: '1_espaceChasse' , (n) printString , '.txt'.
			].
	unTemps + 26 // 52 = (unTemps + 26 / 52)
		ifTrue: 
			[nomFichier := 'chass95a.img'.
"self definirChasse: (self lectureActesChasseFichier: nomFichier)
		surface: 8."
			self activerChasse: 150.	
			"self 
			repartirChasse: (self lectureActesChasseFichier: nomFichier) 
			surface: aSurface 
			pression: p."
			j := j + 1].
	self evoluer: unTemps.
"self sauverLieuDit: 'captLieus' , n printString , '.txt'"!

evoluerChasseAgri: unTemps nSimul: n 
	| j nomFichier aSurface p |
	j := 85.
	"unTemps = 0 ifTrue: [self ouvrirFichier: 'captLieus' , n printString , '.txt']."
	unTemps // 52 = (unTemps / 52) ifTrue: [self retirerChasse].
	unTemps = 1274 ifTrue: [self sauverPopu: 'R2StructurePopT1274.txt'].
	unTemps = 1300
		ifTrue: 
			[self sauver: '2_popdjemiong' , (n) printString , '.txt'.
			self sauverCaptures: '2_captdjemiong' , (n) printString , '.txt'.
			self sauverIndice: '2_espaceChasse' , (n) printString , '.txt'.
			].
	unTemps + 26 // 52 = (unTemps + 26 / 52)
		ifTrue: 
			[nomFichier := 'chass95a.img'.
"self definirChasseAgri: (self lectureActesChasseFichier: nomFichier)
		surface: 8."
			self activerChasse: 150.	
			"self 
			repartirChasse: (self lectureActesChasseFichier: nomFichier) 
			surface: aSurface 
			pression: p."
			j := j + 1].
	unTemps > 1274 ifTrue: [self evoluer: unTemps saveCapt: 'R2StructurePopLastHs.txt']
	ifFalse: [self evoluer: unTemps].
"self sauverLieuDit: 'captLieus' , n printString , '.txt'"!

evoluerChasseAgriPermanente: unTemps nSimul: n 
	| j nomFichier aSurface p |
	j := 85.
	unTemps = 0 ifTrue: [self ouvrirFichier: 'captLieus' , n printString , '.txt'].
	unTemps = 2600
		ifTrue: 
			[self sauver: '4_popdjemiong' , (n+5) printString , '.txt'.
			self sauverCaptures: '4_captdjemiong' , (n+5) printString , '.txt'.
			self sauverIndice: '4_espaceChasse' , (n+5) printString , '.txt'.
			].
	unTemps = 0
		ifTrue: 
			[nomFichier := 'chass95a.img'.
"self definirChasseAgri: (self lectureActesChasseFichier: nomFichier)
		surface: 8."
			self activerChasse: 150.	
			"self 
			repartirChasse: (self lectureActesChasseFichier: nomFichier) 
			surface: aSurface 
			pression: p."
			j := j + 1].
	self evoluer: unTemps.
"self sauverLieuDit: 'captLieus' , n printString , '.txt'"!

evoluerChasseurs: unTemps nSimul: n 
	| p |
	p := 150.
	"unTemps = 0 ifTrue: [self ouvrirFichier: 'chasseurs' , n printString , '.txt']."
	unTemps // 52 = (unTemps / 52) ifTrue: [self retirerChasse].
	unTemps = 1300
		ifTrue: 
			[self sauver: '5_pop' , n printString , '.txt'.
			self sauverCaptures: '5_capt' , n printString , '.txt'.
self sauverIndice: '5_espaceChasse' , (n) printString , '.txt'.
			].
	unTemps + 26 // 52 = (unTemps + 26 / 52) ifTrue: [self choixActesChasse: p].
	self evoluer: unTemps.
	"self sauverChasseur: 'chasseurs' , n printString , '.txt'"!

evoluerGroupes: unTemps nSimul: n 
	| p |
	p := 150.
	"unTemps = 0 ifTrue: [self ouvrirFichier: 'chasseurs' , n printString , '.txt']."
	unTemps // 52 = (unTemps / 52) ifTrue: [self retirerChasse].
	unTemps = 1300
		ifTrue: 
			[self sauver: '6_pop' , n printString , '.txt'. self sauverIndice: '6_espaceChasse' , (n) printString , '.txt'.
			self sauverCaptures: '6_capt' , n printString , '.txt'].
	unTemps + 26 // 52 = (unTemps + 26 / 52) ifTrue: [self choixGroupesChasse: p].
	self evoluer: unTemps.
	"self sauverChasseur: 'chasseurs' , n printString , '.txt'"!

initAgents
	| c unPatch |
	super initAgents.
	1 to: 1000
		do: 
			[:i | 
			c := Duiker new init.
			unPatch := nil.
			[unPatch isNil or: [(c estAccueillant: unPatch) not]]
				whileTrue: [unPatch := Cormas selectRandomlyFrom: self theCells].
			c moveTo: unPatch.
			self theDuikers add: c]!

initAgregats
	| leLieu cellLieu ag habitat total totalHabitat |
	self theHuntingLocalitys: OrderedCollection new.
	Transcript cr.
	total := 0.
	totalHabitat := 0.
	1 to: 30
		do: 
			[:i | 
			leLieu := i printString.
			cellLieu := (self theCells select: [:aCell | aCell huntingLocality = leLieu])
						asOrderedCollection.
			ag := HuntingLocality new.
			ag id: leLieu.
			ag resultats: 0.
			ag components: cellLieu.
			(leLieu = '17') not & (leLieu = '21') not & (leLieu = '22') not
				& (leLieu = '23') not & (leLieu = '0') not ifTrue: 
					[habitat := (ag components select: [:c | c isHabitat]) size.
					leLieu , ': ' , habitat printString , ' ' , cellLieu size printString
						printOn: Transcript.
					Transcript cr.
					total := total + cellLieu size.
					totalHabitat := totalHabitat + habitat].
			self theHuntingLocalitys add: ag].
	'Total: ' , totalHabitat printString , ' ' , total printString
		printOn: Transcript.
	Transcript flush!

initAgregatsClp
	self spaceModel
		setAggregates: HuntingLocality
		from: Cell
		attribute: #huntingLocality!

initialize1
	"premiere initialisation, recree la population de Cephalophes"

	| c unPatch nomFichier |
	self theCells do: 
			[:a | a isHunted: false].
	self theDuikers isNil
		ifFalse: [self theDuikers do: [:a | a leave]].
	self theDuikers: OrderedCollection new.
	cephal := OrderedCollection new.
	nomFichier := 'chass95a.img'.
	self definirChasseAgri: (self lectureActesChasseFichier: nomFichier)
		surface: 8.
	self theCells do: [:a | a huntingPressure: 0].
	self initAgregatsClp.
	1 to: 1000
		do: 
			[:i | 
			c := Duiker new initialisation.
			unPatch := nil.
			[unPatch isNil or: [(c estAccueillant: unPatch) not]] whileTrue: 
					[unPatch := Cormas selectRandomlyFrom: self theCells].
			c moveTo: unPatch.
			self theDuikers add: c].

self catchesNumber: 0.
self initData!

initialize2
	"Initialisation en reintroduisant une population de Cephalophes deja cree presente dans Cephal"

	| nomFichier |
	self theCells do: 
			[:a | 
			a huntingPressure: 0;
				isHunted: false].
	nomFichier := 'chass95a.img'.
	self initAgregats.
	self definirChasseAgri: (self lectureActesChasseFichier: nomFichier)
		surface: 8.
	self theCells do: [:a | a huntingPressure: 0].
	self theDuikers: OrderedCollection new.
	cephal do: [:a | self theDuikers add: a copy].
	self theDuikers do: [:c | c moveTo: c patch]!

initializeAvecChasseurs
	| coeffs leLieu cellLieu nbCells nbChasseurs nbTerrainsChasse ch terrainsSelectionnes r lieuDitSelectionne lieuxDitsSansInfo aSurface tabCellulesDispo cellulesDispo sentierChasse cellBase j attaquees precedent ag s |
	self theCells do: 
			[:a | 
			a huntingPressure: 0].
	self theDuikers: OrderedCollection new.
	self theHuntingLocalitys: OrderedCollection new.
	cephal do: [:a | self theDuikers add: a copy].
	self theDuikers do: [:c | c moveTo: c patch].
	coeffs := OrderedCollection new.
	nbCells := 0.
	1 to: 30
		do: 
			[:i | 
			leLieu := i printString.
			cellLieu := (self theCells select: [:aCell | aCell huntingLocality = leLieu])
						asOrderedCollection.
			nbCells := nbCells + cellLieu size.
			coeffs addLast: nbCells / self theCells size].	"En 1995, surface totale chassee = 602 cellules"
	s := 8.
	nbChasseurs := 90.
	tabCellulesDispo := Dictionary new.
	1 to: 30
		do: 
			[:i | 
			leLieu := i printString.
			cellLieu := (self theCells select: [:aCell | aCell huntingLocality = leLieu])
						asOrderedCollection.
			tabCellulesDispo at: leLieu put: cellLieu copy].
	nbTerrainsChasse := 4.
	lieuxDitsSansInfo := #(17 21 22 23).
	self theHunters: OrderedCollection new.
	nbChasseurs timesRepeat: 
			[ch := Hunter new.
			terrainsSelectionnes := 0.
			[terrainsSelectionnes = nbTerrainsChasse] whileFalse: 
					[r := Cormas Random.
					lieuDitSelectionne := coeffs indexOf: (coeffs detect: [:a | a > r]).
					((ch terrainsChasse keys includes: lieuDitSelectionne)
						or: [lieuxDitsSansInfo includes: lieuDitSelectionne]) ifFalse: 
								[leLieu := lieuDitSelectionne printString.
								cellulesDispo := (tabCellulesDispo at: leLieu) copy.
								leLieu = '28' | (leLieu = '5') | (leLieu = '11') | (leLieu = '14')
									| (leLieu = '12') | (leLieu = '2') | (leLieu = '1') | (leLieu = '10')
									| (leLieu = '26') | (leLieu = '3')
									ifTrue: [aSurface := s * 3 / 2]
									ifFalse: [aSurface := s / 2].
								(cellulesDispo isNil not and: [cellulesDispo size >= aSurface]) ifTrue: 
										[sentierChasse := OrderedCollection new.
										cellBase := Cormas selectRandomlyFrom: cellulesDispo.
										cellulesDispo remove: cellBase.
										sentierChasse add: cellBase.
										j := 1.
										attaquees := OrderedCollection new.
										precedent := -2.
										[attaquees size >= (aSurface - 1) or: [precedent = (attaquees size - 1)]]
											whileFalse: 
												[precedent := attaquees size - 1.
												attaquees := (cellBase recursiveNeighbourhood: j) select: 
																[:aCell | 
																aCell huntingLocality = cellBase huntingLocality
																	and: [cellulesDispo includes: aCell]].
												j := j + 1].
										j := 1.
										attaquees do: 
												[:aCell | 
												j < aSurface ifTrue: 
														[cellulesDispo remove: aCell.
														sentierChasse add: aCell].
												j := j + 1]].	"sentierChasse size < aSurface ifTrue: [self halt]."
								ag := HuntingLocality new.
								ag components: sentierChasse.
								self theHuntingLocalitys add: ag.
								ag resultats: OrderedCollection new.
								ch terrainsChasse at: lieuDitSelectionne put: ag.
								terrainsSelectionnes := terrainsSelectionnes + 1]].
			ch dernierLieuDitChasse: (ch terrainsChasse keys asOrderedCollection
						at: (Cormas randomFrom: 1 to: nbTerrainsChasse)).
			self theHunters add: ch]!

initializeAvecGroupes
	| coeffs leLieu cellLieu nbCells nbChasseurs nbTerrainsChasse ch terrainsSelectionnes r lieuDitSelectionne lieuxDitsSansInfo aSurface tabCellulesDispo cellulesDispo sentierChasse cellBase j attaquees precedent ag s g |
	self theCells do: 
			[:a | 
			a huntingPressure: 0].
	self theDuikers: OrderedCollection new.
	self theHuntingLocalitys: OrderedCollection new.
	cephal do: [:a | self theDuikers add: a copy].
	self theDuikers do: [:c | c moveTo: c patch].
	coeffs := OrderedCollection new.
	nbCells := 0.
	1 to: 30
		do: 
			[:i | 
			leLieu := i printString.
			cellLieu := (self theCells select: [:aCell | aCell huntingLocality = leLieu])
						asOrderedCollection.
			nbCells := nbCells + cellLieu size.
			coeffs addLast: nbCells / self theCells size].	"En 1995, surface totale chassee = 602 cellules"
	s := 8.
	nbChasseurs := 92.
	tabCellulesDispo := Dictionary new.
	1 to: 30
		do: 
			[:i | 
			leLieu := i printString.
			cellLieu := (self theCells select: [:aCell | aCell huntingLocality = leLieu])
						asOrderedCollection.
			tabCellulesDispo at: leLieu put: cellLieu copy].
	nbTerrainsChasse := 4.
	lieuxDitsSansInfo := #(17 21 22 23).
	self theHunters: OrderedCollection new.
	self theHuntingGroups: OrderedCollection new.
	1 to: nbChasseurs
		do: 
			[:i | 
			ch := Hunter new.
			self theHunters add: ch.
			i \\ 3 = 0 ifTrue: 
					[g := HuntingGroup new initialize.
					self theHuntingGroups add: g.
					0 to: 2 do: [:jj | g components add: (self theHunters at: i - jj)]]].
	self theHuntingGroups do: 
			[:gx | 
			g := gx.
			terrainsSelectionnes := 0.
			[terrainsSelectionnes = nbTerrainsChasse] whileFalse: 
					[r := Cormas random.
					lieuDitSelectionne := coeffs indexOf: (coeffs detect: [:a | a > r]).
					((g terrainsChasse keys includes: lieuDitSelectionne)
						or: [lieuxDitsSansInfo includes: lieuDitSelectionne]) ifFalse: 
								[leLieu := lieuDitSelectionne printString.
								cellulesDispo := tabCellulesDispo at: leLieu.
								leLieu = '28' | (leLieu = '5') | (leLieu = '11') | (leLieu = '14')
									| (leLieu = '12') | (leLieu = '2') | (leLieu = '1') | (leLieu = '10')
									| (leLieu = '26') | (leLieu = '3')
									ifTrue: [aSurface := s * 3 / 2]
									ifFalse: [aSurface := s / 2].
								(cellulesDispo isNil not and: [cellulesDispo size >= aSurface]) ifTrue: 
										[sentierChasse := OrderedCollection new.
										cellBase := Cormas selectRandomlyFrom: cellulesDispo.
										cellulesDispo remove: cellBase.
										sentierChasse add: cellBase.
										j := 1.
										attaquees := OrderedCollection new.
										precedent := -2.
										[attaquees size >= (aSurface - 1) or: [precedent = (attaquees size - 1)]]
											whileFalse: 
												[precedent := attaquees size - 1.
												attaquees := (cellBase recursiveNeighbourhood: j) select: 
																[:aCell | 
																aCell huntingLocality = cellBase huntingLocality
																	and: [cellulesDispo includes: aCell]].
												j := j + 1].
										j := 1.
										attaquees do: 
												[:aCell | 
												j < aSurface ifTrue: 
														[cellulesDispo remove: aCell.
														sentierChasse add: aCell].
												j := j + 1]].
								ag := HuntingLocality new.
								ag components: sentierChasse.
								ag etatChasse: 0.
								self theHuntingLocalitys add: ag.
								ag resultats: OrderedCollection new.
								g terrainsChasse at: lieuDitSelectionne put: ag.
								terrainsSelectionnes := terrainsSelectionnes + 1]]]!

initSpace
	self spaceModel loadEnvironmentFromFile: ((Cormas mapsPath: self class name)
			construct: 'Djemiong.env').
	self theCells: (self spaceModel elementaryEntities select: [:a | a huntingLocality isNil not]).
	self theCells
		do: 
			[:a | 
			a init.
			a extensiveNeighbourhood: ((a recursiveNeighbourhood: 3)
					select: [:c | c huntingLocality isNil not])]!

lectureActesChasseFichier: nomFichier 
	| dicoActesChasse nbActes leLieu firstCell |
	self readAttribute: 'huntingPressure' type: 'Number' fromFile: nomFichier.
	dicoActesChasse := Dictionary new.
	1 to: 30
		do: 
			[:i | 
			leLieu := i printString.
			firstCell := self theCells detect: [:aCell | aCell huntingLocality = leLieu]
						ifNone: [nil].
			firstCell isNil
				ifTrue: [nbActes := 0]
				ifFalse: [nbActes := firstCell huntingPressure].
			dicoActesChasse at: leLieu put: nbActes].
	^dicoActesChasse!

ouvrirFichier: nomFichier



| newFile stream |

	newFile := nomFichier asFilename.

	stream := newFile writeStream.

	stream close!

readAttribute: attributeName type: attype fromFile: aName 
	"aName = <String> or aName = <Filename> . If aName = <String>, 
	it creates a Filename from maps directory. 
	Example:	aName = 'test.env' or 
	aName = a 
	FATFilename('d:\Vw5i.4\cormas\Models\JLB\maps\test.env')"

	| stream numLigne aName2 value |
	aName class name = #FATFilename
		ifTrue: [aName2 := aName]
		ifFalse: [aName2 := (Cormas mapsPath: self class name)
						construct: aName].
	stream := aName2 asFilename readStream.
	numLigne := 0.
	[stream atEnd]
		whileFalse: 
			[value := stream upTo: Character cr.
			numLigne := numLigne + 1.
			(self spaceModel elementaryEntities at: numLigne)
				perform: (attributeName,':') asSymbol with: (value = 'nil' ifFalse: [value perform: ('as',attype) asSymbol]
					ifTrue: [nil])].
	stream close!

repartirChasse: lesActesDeChasse surface: s pression: p 
	| cellLieu cellLibres cellBase j attaquees precedent |
	lesActesDeChasse keysAndValuesDo: 
			[:leLieu :nbActes | 
			cellLieu := (self theCells select: [:aCell | aCell huntingLocality = leLieu])
						asOrderedCollection.
			nbActes * s >= cellLieu size
				ifTrue: [cellLieu do: [:aCell | aCell huntingPressure: p]]
				ifFalse: 
					[cellLieu do: [:aCell | aCell huntingPressure: 0].
					cellLibres := cellLieu copy.
					nbActes timesRepeat: 
							[cellBase := Cormas selectRandomlyFrom: cellLibres.
							cellBase huntingPressure: p.
							cellLibres remove: cellBase.
							j := 1.
							attaquees := OrderedCollection new.
							precedent := -2.
							[attaquees size >= (s - 1) or: [precedent = (attaquees size - 1)]]
								whileFalse: 
									[precedent := attaquees size - 1.
									attaquees := (cellBase recursiveNeighbourhood: j) select: 
													[:aCell | 
													aCell huntingLocality = cellBase huntingLocality
														and: [aCell huntingPressure = 0]].
									j := j + 1].
							j := 1.
							attaquees do: 
									[:aCell | 
									j <= s ifTrue: 
											[aCell huntingPressure: p.
											cellLibres remove: aCell].
									j := j + 1]]]]!

retirerChasse
	self theCells do: [:a | a huntingPressure: 0].
	self theHuntingLocalitys do: [:a | a resultats: 0]!

sauver: nomFichier 
	| newFile stream |
	newFile := nomFichier asFilename.
	stream := newFile writeStream.
	populationTotale value do: [:a | stream nextPutAll: a first printString , '\' withCRs].
	stream close!

sauverCaptures: nomFichier 
	| newFile stream |
	newFile := nomFichier asFilename.
	stream := newFile writeStream.
	captures value do: [:a | stream nextPutAll: a first printString , '\' withCRs].
	stream close!

sauverCephal: c inFile: nomFichier 
	| newFile stream |
	newFile := nomFichier asFilename.
	stream := newFile appendStream.
	stream nextPutAll: c age printString, '	', c sexe asString, '\' withCRs.
	stream close!

sauverChasseur: nomFichier 
	| c |
	c := OrderedCollection new.
	self theHunters do: [:a | c add: a sommeChasse].
	Cormas saveCollec: c inFile: nomFichier!

sauverIndice: nomFichier 
	| newFile stream |
	newFile := nomFichier asFilename.
	stream := newFile writeStream.
	espaceChasse value do: [:a | stream nextPutAll: a first printString , '\' withCRs].
	stream close!

sauverLieuDit: nomFichier 
	| c |
	c := OrderedCollection new.
	(self theHuntingLocalitys
		asSortedCollection: [:a1 :a2 | a1 id asNumber < a2 id asNumber])
			do: [:a | c add: a resultats].
	Cormas saveCollec: c inFile: nomFichier!

sauverPopu: nomFichier 
	| newFile stream |
	newFile := nomFichier asFilename.
	stream := newFile writeStream.
	self theDuikers do: 
			[:c | 
			stream nextPutAll: c age printString , '	' , c sexe asString , '\' withCRs].
	stream close! !

!CormasNS.Models.Djemiong.Djemiong methodsFor: 'probes'!

bebes
	^(self theDuikers select: [:d | d age = 0]) size!

catchesNumber
	^catchesNumber!

occupation
	| cptEffTerritoire femellesEnCouple effTerritoire |
	cptEffTerritoire := 0.
	femellesEnCouple := self theDuikers
				select: [:a | a sexe = #femelle and: [a partner notNil]].
	femellesEnCouple do: 
			[:f | 
			effTerritoire := (f patch theOccupants at: #Duiker) size.
			cptEffTerritoire := cptEffTerritoire + effTerritoire].
	^femellesEnCouple isEmpty
		ifTrue: [0]
		ifFalse: [cptEffTerritoire / femellesEnCouple size]!

populationTotale
	^self theDuikers size / 49.74! !


CormasNS.Models.Djemiong defineClass: #Hunter
	superclass: #{CormasNS.Kernel.AgentLocation}
	indexedType: #none
	private: false
	instanceVariableNames: 'terrainsChasse dernierLieuDitChasse '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Djemiong'!

CormasNS.Models.Djemiong.Hunter defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Djemiong.Hunter class methodsFor: 'init'!

initialize
	typeEntite := #societe.
	estEntiteType := false! !

!CormasNS.Models.Djemiong.Hunter class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Djemiong.Hunter methodsFor: 'procedures'!

dernierLieuDitChasse
^dernierLieuDitChasse!

dernierLieuDitChasse: uneValeur
dernierLieuDitChasse := uneValeur!

terrainsChasse
^terrainsChasse!

terrainsChasse: uneValeur
terrainsChasse := uneValeur! !

!CormasNS.Models.Djemiong.Hunter methodsFor: 'init'!

initialize
terrainsChasse := Dictionary new.!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.Djemiong.Hunter methodsFor: 'controle'!

choixLieuDit
	| lieuxDitsPossibles |
	lieuxDitsPossibles := OrderedCollection new.
	self terrainsChasse keys do: [:ld | ld = self dernierLieuDitChasse ifFalse: [lieuxDitsPossibles addLast: ld]].
	self dernierLieuDitChasse: (Cormas selectRandomlyFrom: lieuxDitsPossibles).
	^self dernierLieuDitChasse!

sommeChasse
	| c |
	c := 0.
	terrainsChasse values do: [:s | c := c + s resultats].
	^c! !


CormasNS.Models.Djemiong defineClass: #HuntingLocality
	superclass: #{CormasNS.Kernel.SpatialEntityAggregate}
	indexedType: #none
	private: false
	instanceVariableNames: 'actesChasse resultats etatChasse '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Djemiong'!

CormasNS.Models.Djemiong.HuntingLocality defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Djemiong.HuntingLocality class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Djemiong.HuntingLocality methodsFor: 'procedures'!

actesChasse
^actesChasse!

actesChasse: uneValeur
actesChasse := uneValeur!

etatChasse
^etatChasse!

etatChasse: uneValeur
etatChasse := uneValeur!

resultats
^resultats!

resultats: uneValeur
resultats := uneValeur! !

!CormasNS.Models.Djemiong.HuntingLocality methodsFor: 'pov'!

pov
^ColorValue constantNames at: self id asNumber! !

!CormasNS.Models.Djemiong.HuntingLocality methodsFor: 'init'!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !


CormasNS.Models.Djemiong defineClass: #HuntingGroup
	superclass: #{CormasNS.Kernel.Group}
	indexedType: #none
	private: false
	instanceVariableNames: 'terrainsChasse '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Djemiong'!

CormasNS.Models.Djemiong.HuntingGroup defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Djemiong.HuntingGroup class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Djemiong.HuntingGroup methodsFor: 'procedures'!

terrainsChasse
^terrainsChasse!

terrainsChasse: uneValeur
terrainsChasse := uneValeur! !

!CormasNS.Models.Djemiong.HuntingGroup methodsFor: 'init'!

initialize
super initialize.
terrainsChasse := Dictionary new.!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.Djemiong.HuntingGroup methodsFor: 'controle'!

choixTerrains
	"etat chasse = 0 -> chasse, 1 un an de repos, 2 deux ans de repos"

	| chasseurs sentiers sentiersTries r terrainsAdonner o tad |
	chasseurs := self components.
	chasseurs do: [:a | a terrainsChasse: Dictionary new].
	sentiers := self terrainsChasse values.
	sentiers
		do: [:s | s etatChasse > 0 ifTrue: [s etatChasse: s etatChasse + 1]].
	sentiersTries := sentiers asSortedCollection: [:a1 :a2 | a1 etatChasse < a2 etatChasse].
	sentiersTries last etatChasse = 0
		ifTrue: [sentiersTries last etatChasse: 1].
	sentiersTries last etatChasse = 4 ifTrue: 
			[sentiersTries last etatChasse: 0.
			r := Cormas randomFrom: 1 to: 3.
			(sentiersTries at: r) etatChasse: 1].
	terrainsAdonner := self terrainsChasse select: [:a | a etatChasse = 0].
	o := OrderedCollection new.
	terrainsAdonner do: [:t | o addAll: t components].
	chasseurs do: 
			[:c | 
			tad := terrainsAdonner associations first.
			c terrainsChasse add: tad.
			terrainsAdonner removeKey: tad key].
	^o! !


CormasNS.Models.Djemiong defineClass: #Duiker
	superclass: #{CormasNS.Kernel.AgentLocation}
	indexedType: #none
	private: false
	instanceVariableNames: 'age dureeGestation sexe ageMiseBas partner '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Djemiong'!

CormasNS.Models.Djemiong.Duiker defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Djemiong.Duiker class methodsFor: 'init'!

initialize
	typeEntite := #societe.
	estEntiteType := false! !

!CormasNS.Models.Djemiong.Duiker class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Djemiong.Duiker methodsFor: 'procedures'!

moveTo2: aPatch 
	aPatch isNil ifTrue: [self halt].
	self patch: aPatch.
	self center: self patch center.
	self defineVisualState.
	(self patch theOccupants at: self class name) add: self.
	self displayOn: self patch view graphicsContext.
	self displayOn: self patch view buffer graphicsContext! !

!CormasNS.Models.Djemiong.Duiker methodsFor: 'controle'!

chercherPartenaire
	| tmp |
"	tmp := patch extensiveNeighbourhood select: [:unP | (unP theOccupants at: self class name) notNil & (self estAccueillant: unP)]."
	tmp := patch extensiveNeighbourhood select: [:unP | (unP theOccupants at: self class name) notNil].
	tmp do: [:unP | (unP theOccupants at: self class name)
			do: [:unC | (unC sexe = self sexe) not & unC partner isNil &  unC dead not & unC isAdulte ifTrue: [^unC]]].
	^nil!

deplacement
	| autreAilleurs nouveauLieu |
	autreAilleurs := self rencontrerPartenaire.
	autreAilleurs isNil
		ifTrue: 
			[nouveauLieu := (patch extensiveNeighbourhood select: 
							[:unP | 
							(unP theOccupants at: self class name) isEmpty & (self estAccessible: unP)]) asOrderedCollection.
			nouveauLieu isEmpty ifFalse: 
					[self leave.
					self
						moveTo: (nouveauLieu at: (Cormas random * (nouveauLieu size - 1)) rounded + 1)]]
		ifFalse: 
			[partner := autreAilleurs at: 1.
			self leave.
			self moveTo: (autreAilleurs at: 2).
			partner partner: self.
			partner leave.	"partenaire arriver: patch]"
			partner moveTo: (autreAilleurs at: 2).
			(self estAccueillant: (autreAilleurs at: 2)) not ifTrue: [self halt]]!

estAccessible: unPatch 
	"patch sans agriculture (4)"

	unPatch isNil ifTrue: [^false].
	^(unPatch huntingLocality = '17') not & (unPatch huntingLocality = '21') not
		& (unPatch huntingLocality = '22') not
			& (unPatch huntingLocality = '23') not
			& (unPatch huntingLocality isNil) not!

estAccueillant: unPatch 
	"patch sans route (2) ni eau (3) ni agriculture (4)"

	unPatch huntingLocality isNil ifTrue: [^false].
	^unPatch road not & unPatch river not & (unPatch huntingLocality = '17') not
		& (unPatch huntingLocality = '21') not
			& (unPatch huntingLocality = '22') not
			& (unPatch huntingLocality = '23') not!

evoluer: unTemps 
	|   petit |
	petit := 0.
	age := age + 1.
	self mortaliteNaturelle.
	self dead
		ifTrue: [^0]
		ifFalse: 
			[self mortaliteChasse.
			self dead ifTrue: [^1]].
	self isAdulte & partner isNil ifTrue: [self deplacement].
	self sexe = #femelle
		ifTrue: 
			[dureeGestation > 0 ifTrue: [dureeGestation := dureeGestation + 1].
			dureeGestation = 30
				ifTrue: 
					[dureeGestation := 0.
					petit := self class new init0.
					petit patch: patch]
				ifFalse: [(partner notNil and: [dureeGestation = 0 and: [((patch theOccupants at: self class name)
								contains: [:a | a age < 21]) not]])
						ifTrue: [dureeGestation := 1]]].
	^petit!

evoluer: unTemps t: t p: p
	|   petit |
	petit := 0.
	age := age + 1.
	self mortaliteNaturelle: t taux: p.
	self dead
		ifTrue: [^0]
		ifFalse: 
			[self mortaliteChasse.
			self dead ifTrue: [^1]].
	self isAdulte & partner isNil ifTrue: [self deplacement].
	self sexe = #femelle
		ifTrue: 
			[dureeGestation > 0 ifTrue: [dureeGestation := dureeGestation + 1].
			dureeGestation = 30
				ifTrue: 
					[dureeGestation := 0.
					petit := self class new.
					petit patch: patch]
				ifFalse: [(partner notNil and: [dureeGestation = 0 and: [((patch lesOccupants at: self class name)
								contains: [:a | a age < 21]) not]])
						ifTrue: [dureeGestation := 1]]].
	^petit!

isAdulte
	^(self sexe = #male and: [self age > 95])
		or: [self sexe = #femelle and: [self age > 72]]!

mortaliteChasse
	(self patch huntingPressure > 0
		and: [Cormas random < (self patch huntingPressure / 1000)]) ifTrue: 
				[partner notNil ifTrue: 
						[partner partner: nil.
						partner := nil].
				dead := true]!

mortaliteNaturelle
	(self age < 40 and: [Cormas random < (1 - (0.7 raisedTo: 1 / 40))])
		ifTrue: [self dead: true].
	(self age >= 40 and: [self age < 280 and: [Cormas random < (1 - (0.95 raisedTo: 1 / 240))]])
		ifTrue: 
			[self partner notNil
				ifTrue: 
					[self partner partner: nil.
					self partner: nil].
			self dead: true].
	(self age >= 281 and: [Cormas random < (1 - (0.01 raisedTo: 1 / 100))])
		ifTrue: 
			[self partner notNil
				ifTrue: 
					[self partner partner: nil.
					self partner: nil].
			self dead: true]!

mortaliteNaturelle: ageVieillesse taux: p1

"juveniles: 30% disparaissent en 40 semaines"
	(self age < 40 and: [Cormas random < (1 - (0.7 raisedTo: 1 / 40))])
		ifTrue: [self dead: true].

"adultes vigoureux: p1% auront disparu a l'age de la vieillesse"
	(self age >= 40 and: [self age < ageVieillesse and: [Cormas random < (1 - (p1 raisedTo: 1 / (ageVieillesse - 40)))]])
		ifTrue: 
			[self partner notNil
				ifTrue: 
					[self partner partner: nil.
					self partner: nil].
			self dead: true].

"vieux adultes: 99% auront disparu au bout de 375 semaines"
	(self age >= (ageVieillesse + 1) and: [Cormas random < (1 - (0.01 raisedTo: 1 / (375 - ageVieillesse)))])
		ifTrue: 
			[self partner notNil
				ifTrue: 
					[self partner partner: nil.
					self partner: nil].
			self dead: true]!

rencontrerPartenaire
	"Rencontre l autre sur un Patch vide, sans eau ni route"

	| lesTerritoiresPossibles partenairePotentiel lieuxPartenaire nouvelHabitat |
	(partenairePotentiel := self chercherPartenaire) isNil ifTrue: [^nil].
	lieuxPartenaire := partenairePotentiel patch extensiveNeighbourhood select: [:unP | self estAccueillant: unP].
	lesTerritoiresPossibles := OrderedCollection new.
	((patch theOccupants at: self class name) size = 1 and: [self estAccueillant: patch]) 
		ifTrue: [lesTerritoiresPossibles add: patch].
	((partenairePotentiel patch theOccupants at: self class name) size = 1 and: [self estAccueillant: partenairePotentiel patch])
		ifTrue: [lesTerritoiresPossibles add: partenairePotentiel patch].
	lieuxPartenaire do: [:unP | ((unP theOccupants at: self class name) isNil and: [patch extensiveNeighbourhood includes: unP])
			ifTrue: [lesTerritoiresPossibles add: unP]].
	lesTerritoiresPossibles isEmpty
		ifTrue: [^nil]
		ifFalse: 
			[nouvelHabitat := Cormas selectRandomlyFrom: lesTerritoiresPossibles.
			(self estAccueillant: nouvelHabitat) not ifTrue: [self halt].
			^Array with: partenairePotentiel with: nouvelHabitat]! !

!CormasNS.Models.Djemiong.Duiker methodsFor: 'pov'!

povCouple

^self partner isNil not 
	ifTrue: [^#withPartner]
	ifFalse: [^#alone]!

povSex
"^#male ^#female"
^self sexe! !

!CormasNS.Models.Djemiong.Duiker methodsFor: 'init'!

init
	super init.
	dead := false.
	Cormas random > 0.5
		ifTrue: [self sexe: #male]
		ifFalse: [self sexe: #femelle].
	self age: (Cormas randomFrom: 1 to: 80).
	dureeGestation := 0.
	ageMiseBas := 0.!

init0
	super init.
	self dead: false.
	Cormas random > 0.5
		ifTrue: [self sexe: #male]
		ifFalse: [self sexe: #femelle].
	self age: 0.
	self dureeGestation: 0.
	ageMiseBas := 0.!

initialisation
	super init.
	dead := false.
	Cormas random > 0.5
		ifTrue: [self sexe: #male]
		ifFalse: [self sexe: #femelle].
	self age: (Cormas randomFrom: 1 to: 80).
	dureeGestation := 0.
	ageMiseBas := 0.!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.Djemiong.Duiker methodsFor: 'accessing'!

age ^age!

age: aVal age := aVal!

ageMiseBas
^ageMiseBas!

ageMiseBas: uneValeur
ageMiseBas := uneValeur!

dureeGestation ^dureeGestation!

dureeGestation: aVal dureeGestation := aVal!

partner
	^partner!

partner: aVal 
	partner := aVal!

sexe
^sexe!

sexe: uneValeur
sexe := uneValeur! !


#{CormasNS.Models.Djemiong.Hunter} initialize!

#{CormasNS.Models.Djemiong.Duiker} initialize!

